;
; Ce programme permet de mettre un point d'arret dans un programme
; sans rien gerer (mode interactif) et interagit a la souris
; (dans certains cas, plus adequat que le clavier)
;
; Si on est en batch, on ne s'y arrete pas (pas d'affichage)
; Si on est en mode PostScript, on ne s'y arrete pas
; Sinon
; Si on est en mode X ou Win, on a une petite fenetre
; Dans les autres cas (non testes a ce jour !), on passe en mode clavier
;
; Si on souhaite "vraiment" revenir dans la precedure et s'y arreter,
; il suffit de faire ".s 3"
; Si on veut continuer sans s'arreter, on fait ".c"
;
; ---------------------------
; listes des modifications:
;
; AC, 10/05/2005:
; - grace a AC_UMENU/AC_WMENU, le mode Win redevient interactif aussi
;
; AC, 06/05/2005:
; - a la demande des utilisateurs sous MS-win,
;   on ajoute ce cas ... au clavier (obsolete le 10/05/2005)
; - mise a jour de la doc
;
; AC, 04/02/2001: remise a jour de la version initiale
;
; -ajout du mot clef "batch" pour
; pouvoir faire tourner les batchs quand meme !
; -ajout de la gestion du "!D.name" pour gerer
; le probleme le plus frequent : impossible d'etre actif sous "PostScript"
; ""
;
; Usage: AC_DELAIS
;
pro AC_DELAIS, batch=batch, help=help, test=test, verbose=verbose
;
if KEYWORD_SET(help) then begin
    print, 'pro AC_DELAIS will asks if you want to stop or continue the main program;'
    print, 'usefull for conditionnal test points (go back to main with ".s 2")'
    print, 'or to visualize temporary plots ...'
    print, ' '
    print, 'CALLING SEQUENCE : pro AC_DELAIS, batch=batch, help=help, test=test'
    return
endif
;
mess=AC_SETMESSAGES('AC_DELAIS')
;
if KEYWORD_SET(verbose) then print, mess.info+'!D.name: ', !D.name
;
; si on est en mode "PostScript", on sort tout de suite
;
if (!D.name EQ 'PS') then begin
    if KEYWORD_SET(verbose) then begin
        print, mess.info+'AC_DELAIS called but PS mode actif !'
    endif
    return
endif
;
; si on est en /Batch, on sort tout de suite
;
if KEYWORD_SET(batch) then return
;
; ------------------------------------
; desormais, on n'est pas en batch ou en mode PS !
; on est en 'X' ou en 'WIN' (ou 'MAC', jamais teste)
;
texte=['suite du programme,', $
       'arret et fermeture des fenetres (AC_RESET)',$
       'arret du programme.']
;
if ((!D.name EQ 'X') OR (!D.name EQ 'WIN')) then begin
    reponse=AC_WMENU(texte,init=0)
endif else begin
    print, mess.question+'Please select one in the 3 solutions:'
    print, '0 : '+texte[0]
    print, '1 : '+texte[1]
    print, '2 : '+texte[2]
    read, mess.question+' Selected value : ', reponse
endelse
;
; -------------------------------
txt='Faire ".s 3" pour retourner (et s''arreter)'
txt=txt+'dans la procedure appelante ...'
;
case reponse of
    0:	begin
; il faut garder cette structure pour atteindre le test en bas !!
    end
    1:	begin
        AC_RESET
        print, txt
        STOP
    end
    2:	begin
        print, txt
        STOP
    end
endcase
;
if KEYWORD_SET(test) then STOP
;
end
;
