;
; AC, le 03/05/2005
; Purpose: This function computes in a Time Serie ("signal")
; the Time Constant of a upward or downward step
;
; It is assumed that the time serie :
;   -(1) contains one and only one step
;   -(2) is monotonic
; in order to simplify the code. (Absolutely no gestion of pb and errors)
;
; d'apres la formule magique de Michel Piat
; 
function AC_TIMECONSTANTE, signal, delta_time=delta_time, $
                           test=test, display=display
;
; si le pas temporel n'est pas fourni, il est implicitement
; egal a 1
;
if (N_ELEMENTS(delta_time) EQ 0) then delta_time=1.
;
signal_min=MIN(signal)
signal_max=MAX(signal)
;
scale=signal_max-signal_min
;
val_at10=MIN(ABS(signal-(signal_min+0.1*scale)),i10)
val_at90=MIN(ABS(signal-(signal_max-0.1*scale)),i90)
;
time_constante=(i90-i10)/2.22*delta_time
;
if KEYWORD_SET(display) then begin
    plot, signal, /ynozer
    oplot, [i10, i10], !y.crange, col=!col_r
    oplot, [i90, i90], !y.crange, col=!col_r
endif
;
if KEYWORD_SET(test) then STOP
;
return, time_constante
end
