;
; Creation par AC le 05/02/2004 a Paris LERMA
;
; This program initiliazes the values for the Field of View (FoV)
; at each frequency
;
; Historique des modifications:
;
; 06/02/04: all the values tabulated here have been provided
;           by Jean-Michel Lamarre during a meeting yesterday
;
;--------------------------------------------- 
;
pro PLANCK_INIT_FOV, bavard=bavard, test=test, help=help
;
mess=AC_SETMESSAGES('PLANCK_INIT_FOV')
;
if KEYWORD_SET(help) then begin
    print, 'pro PLANCK_INIT_FOV, bavard=bavard, $'    
    print, '               test=test, help=help'
    return
endif
;
;--------------------------------------------- 
;
DEFSYSV, '!fov_flag_init', exist=flag_init
if (flag_init EQ 1) then begin
    print, mess.warning+' it is NOT the first time that PLANCK_INIT_FOV is called !'
    print, mess.warning+' --> you must go outside IDL to change FOV values.'
    print, mess.warning+' No change to previous FOV values'
    if KEYWORD_SET(bavard) then begin
        print, mess.info+' ReadOnly SysVar !fov_flag_init was set'
        print, mess.info,'content of Structure !fov is:'
        HELP,/structure, !fov
    endif
    return
endif else begin
    Read_only=1
    DEFSYSV, '!fov_flag_init', 1, Read_only
endelse
;
;--------------------------------------------- 
; Cette table
;
fov={units : 'ArcSec', $
     f100 : 9.5, $
     f143 : 7.2, $
     f217 : 5.0, $
     f353 : 5.0, $
     f545 : 5.0, $
     f857 : 5.0 }
;
; on le passe en variable systeme
;
DEFSYSV, '!fov', fov
;
print, mess.info+"Values for Structure !Fov has been initialized" 
;
if KEYWORD_SET(bavard) then begin
    print, mess.info+' ReadOnly SysVar !fov_flag_init was set'
    print, mess.info,'content of Structure !fov is:'
    HELP,/structure, !fov
endif
if KEYWORD_SET(test) then STOP
;
end
