;
; Creation par AC le 11/05/2004 a Meudon
;
; But: ce programme simule l'electronique d'integration
;
; Historique des modifications:
;
; AC le 11/05/2004:
; - pour le moment, le prog n'est pas pluggue avec celui de JMG
;
; Dependances (Ce programme necessite):
;      AC_SETMESSAGES 
;
pro REU_INTEGRATOR, TempIn, $ ;; liste de temperatures d'entree (array)
                    TempOut, $ ;; liste de temperatures de sortie (array)
                    delta_t=delta_t, IntegTime=IntegTime, TimeOut=TimeOut, $
                    display=display, bavard=bavard, $
                    debug=debug, test=test, help=help
;
mess=AC_SETMESSAGES('REU_INTEGRATOR')
;
;if (N_PARAMS() lt 1) then begin
;	print, mess.fatal+'missing arguments'
;	help=1
;endif
;
if KEYWORD_SET(help) then begin
    print, ' Not up to date'
    ;;
    print, 'pro REU_INTEGRATOR, TempIn, TempOut, $'
    print, '                    delta_t=delta_t, IntegTime=IntegTime, TimeOut=TimeOut, $'
    print, '                    display=display, bavard=bavard, $'
    print, '                    debug=debug, test=test, help=help'
    return
endif
;
if (N_ELEMENTS(IntegTime) NE 1) then begin
    IntegTime=0.01
    print, mess.info+"default value for [IntegTime] is (s):", IntegTime
endif
;
nbp_in=N_ELEMENTS(TempIn)
TimeIn=Delta_t*Dindgen(nbp_in)
nbp_out=ROUND(nbp_in*Delta_t/IntegTime)
if (nbp_out LE 1) then begin
    print, mess.fatal+"the output number of integrated points is too small"
    return
endif
TimeOut=IntegTime*(Dindgen(nbp_out)+0.5)
TempOut=FLTARR(nbp_out)
;
; combien de points prend-on a chaque integration ?
;
duration=ROUND(IntegTime/Delta_t)
;
for i=0L, (nbp_out-1) do begin
    debut=i*duration
    fin=(i+1)*duration-1
    TempOut(i)=TOTAL(TempIn(debut:fin),/double)/FLOAT(duration)
endfor
;
if KEYWORD_SET(display) then begin
    plot, TimeIn, TempIn
    oplot, TimeOut, TempOut, psym=-1, color=!col_r
endif
;
if KEYWORD_SET(debug) then STOP
if KEYWORD_SET(test) then STOP
;
end
