;
; AC le 11/05/2005
;
; This program convert Bolometer Temperature to Bolo Voltage.
;
; We can have 4 differents ways to call this program,
; depending on the size of the input arrays "temperature" and "current"
; The only possible trouble can come if both sizes are GT 1 and
; differents (or if one array is missing !)
;
; sizes of : temperature, current, output
;                1          1        1
;                N          1        N
;                1          N        N
;                N          N        N
; are OK
;
function TEMPERATURE2VOLTAGE, temperature, current, bolo=bolo, $
                              test=test, help=help
;
mess=AC_SETMESSAGES('TEMPERATURE2VOLTAGE')
;
if (N_PARAMS() lt 2) then begin
	print, mess.fatal+'missing arguments'
	help=1
endif
;
if KEYWORD_SET(help) then begin
    print, 'function TEMPERATURE2VOLTAGE, temperature, current, bolo=bolo, $'
    print, '                              test=test, help=help'
    print, ''
    print, 'CALLING SEQUENCE : voltage=TEMPERATURE2VOLTAGE(temp, current, bolo=bolo)'
    print, ''
    print, 'N.B.: Temp and Current Arrays sizes can be (1,1), (1,N), (N,1) or (N,N)'
    return, -1
endif
;
; on verifie les 4 cas possibles
;
nbp_temp=N_ELEMENTS(temperature)
nbp_cur=N_ELEMENTS(current)
;
if (nbp_temp GT 1) AND (nbp_cur GT 1) then begin
    if (nbp_temp NE nbp_cur) then begin
        print, mess.fatal+'If both arrays have sizes greater than 1,'
        print, mess.fatal+'both array must have the same size !'
        txt=mess.fatal+'nbp_temp : '+STRING(nbp_temp)
        print, STRCOMPRESS(txt+', nbp_cur : '+STRING(nbp_cur))
        return, -1
    endif
endif
;
r0=DOUBLE(bolo.Rinf)
Tg=DOUBLE(bolo.Ttrans)
m=DOUBLE(bolo.Alpha)
;
voltage=EXP((Tg/temperature)^m)*r0*current
;
if KEYWORD_SET(test) then STOP
;
return, voltage
;
end
