;
; AC, le 14/04/2005
; this file provides a simple demonstration of the package
;
pro TEST_DEMO, bolo_name=bolo_name, batch=batch, $
               help=help, test=test, verbose=verbose
;
mess=AC_SETMESSAGES('TEST_DEMO')
;
if KEYWORD_SET(help) then begin
    print, 'pro TEST_DEMO, bolo_name=bolo_name, batch=batch, $'
    print, '               help=help, test=test, verbose=verbose'
    return
endif
;
; on ferme toutes les fenetres actives afin que
; la succession des traces soit claire !
;
AC_RESET
;
; ------------------------------------
; extraction of ONE bolometer in the list
;
if KEYWORD_SET(batch) then begin
    bolo_list=LIST_BOLO_READFILE(/verbose)
    if (N_ELEMENTS(bolo_name) EQ 0) then bolo_name='demo100'
    bolo=LIST_BOLO_EXTRACT(bolo_list, name=bolo_name,/verbose)
endif else begin
    bolo=LIST_BOLO_SELECT()
endelse
;
; la structure "bolo" en est-elle vraiment une ?
;
if (N_TAGS(bolo) EQ 0) then begin
    print, mess.fatal+'No Bolo selected'
    return
endif
;
print, mess.info, 'selected bolo is: ', bolo.name
if KEYWORD_SET(verbose) then print, mess.info, 'bolo parameters are:', bolo 
;
; --------------------------------------------
; creation d'un signal optique
;
delta_t=1e-4
nbp=1e4
TimeIn=delta_t*FINDGEN(nbp)
;
op=CREATE_OPT_SIGNAL(delta_t=delta_t, nbp=nbp, /beam, amp=2.7e-13, /center)
; we add a background
op=op+3.8e-13
;
plot, TimeIn, op, xtitle='time (s)', ytitle='Optical power (Watts)', $
  title='Input signal', /ynoze
if NOT(KEYWORD_SET(batch)) then AC_DELAIS
;
; Le courant est mis a 1e-9 Amperes ...
; Notons que ce courant peut etre un table
; de meme taille que TimeIn ...
;
courant=1.e-9
;
; ----------------------------------------------
; Calcul Temperature modele direct
;
t1=BOLO_DIRECT_MODEL(op, bolo=bolo, cur=courant, delta_t=delta_t)
plot, TimeIn, t1, xtitle='time (s)', ytitle='Kelvins', $
  title='Bolo temperature', /ynoze
if NOT(KEYWORD_SET(batch)) then AC_DELAIS
;
; ----------------------------------------------
; Calcul inversion
;
t2=BOLO_INVERT_MODEL(t1, bolo=bolo, cur=courant, delta_t=delta_t)
;
plot, TimeIn, t2, xtitle='time (s)', ytitle='Optical power (Watts)', $
  title='Inverted Optical power', /ynoze
if NOT(KEYWORD_SET(batch)) then AC_DELAIS
;
plot, TimeIn, t2-op, xtitle='time (s)', ytitle='Optical power (Watts)', $
  title='Difference between Input and Inverted Optical Power', /ynoze
if NOT(KEYWORD_SET(batch)) then AC_DELAIS
;
; ----------------------------------------------
; La meme chose mais avec simulation du REU integrator
;
print, mess.warning+'-----------------------------'
print, mess.warning+'this part is not READY now'
print, mess.warning+'-----------------------------'
;
REU_INTEGRATOR, t1, t1b, delta_t=delta_t, IntegTime=0.01, TimeOut=Timeout
ndt=Timeout(1)-Timeout(0)
;
; inversion after integration
t2b=BOLO_INVERT_MODEL(t1b, bolo=bolo, cur=1e-9, delta_t=ndt)
;
window, 0
plot, TimeIn, t2
oplot, TimeOut, t2b, col=!col_r, psym=-1
;
window, 1
plot, TimeIn, t1> 0.15, /yn
oplot, TimeOut, t1b, col=!col_r, psym=1
;
if KEYWORD_SET(test) then STOP
;
end

