;
; AC 03/05/2005
;
; This program helps to check wether computation for
; basic cases go is the good direction
;
pro TEST_TIME_CONST, nbp=nbp, amp=amp, back=back, help=help, test=test
;
mess=AC_SETMESSAGES('TEST_TIME_CONST')
;
if KEYWORD_SET(help) then begin
    print, 'pro TEST_TIME_CONST, nbp=nbp, amp=amp, back=back, test=test, help=help'
    print, ''
    print, 'parameter AMP  : amplitude of the optical step'
    print, 'parameter BACK : amplitude of the optical background'
endif
;
; on ferme toutes les fenetres actives afin que
; la succession des traces soit claire !
;
AC_RESET
;
; selection interactive d'un bolo
;
bolo=LIST_BOLO_SELECT()
if (N_TAGS(bolo) LE 0) then begin
    print, mess.fatal+'No selected bolo !'
    return
endif
;
if (N_ELEMENTS(nbp) EQ 0) then nbp=1e4
;
delta_t=1e-4
;
; we have a default source level, this can be changed through Keyword AMP=
;
if (N_ELEMENTS(amp) EQ 0) then amp=2.7e-13
;
; creation du signal incident
;
op_up=CREATE_OPT_SIGNAL(delta_t=delta_t, nbp=nbp, /step, amp=amp, /center)
op_down=CREATE_OPT_SIGNAL(delta_t=delta_t, nbp=nbp, /step, amp=-amp, /center)
print, mess.info+'Don''t care : the NEGATIVE value is OK here !'
;
; we add a background, this can be changed through Keyword BACK=
;
if (N_ELEMENTS(back) EQ 0) then back=3.8e-13
op_up=op_up+back
op_down=op_down+back
;
; om previent quand meme si les valeurs sont aberrantes
;
out=OUT_OF_RANGE(amp, min=1e-15,max=1e-10,'Amplitude')
out=OUT_OF_RANGE(back, min=1e-15,max=1e-10,'Background')
; ----------------------------------------
;
t_up=BOLO_DIRECT_MODEL(op_up, bolo=bolo, t_bath=.10)
t_down=BOLO_DIRECT_MODEL(op_down, bolo=bolo, t_bath=.10)
;
;plot, t, /ynoze
;
xr=1000
;
!p.multi=[0,0,2]
plot, t_up(nbp/2-xr/10:nbp/2+2*xr), /ynoze
plot, t_down(nbp/2-xr/10:nbp/2+2*xr), /ynoze
!p.multi=0
;
; calcul des 2 constantes de temps sur les courbes simulees
;
tt_up  =t_up  (nbp/2-xr/10:nbp/2+2*xr)
tt_down=t_down(nbp/2-xr/10:nbp/2+2*xr)
;
tau_simul_up=AC_TIMECONSTANTE( tt_up, delta_time=delta_t)
tau_simul_down=AC_TIMECONSTANTE(tt_down, delta_time=delta_t)
print, 'tau_simul UP', tau_simul_up
print, 'tau_simul DOWN', tau_simul_down
;
; calcul des 2 constantes de temps theroriques
;
t_100mk=0.1
beta_1=bolo.beta+1
pseudo_pf=bolo.gbol/(beta_1)/(T_100mk^bolo.beta)
;
tmax_up=MAX(tt_up)
tmin_up=MIN(tt_up)
tmax_down=MAX(tt_down)
tmin_down=MIN(tt_down)
;
g_up=pseudo_pf*(tmax_up^beta_1-tmin_up^beta_1)/(tmax_up-tmin_up)
g_down=pseudo_pf*(tmax_down^beta_1-tmin_down^beta_1)/(tmax_down-tmin_down)
tau_theo_up=bolo.c0/g_up
tau_theo_down=bolo.c0/g_down
print, 'tau_theo UP', tau_theo_up
print, 'tau_theo DOWN', tau_theo_down
;
if KEYWORD_SET(test) then STOP
;
end
