;
; AC 03/05/2005
;
; This program helps to check wether computation for
; basic cases go is the good direction
;
pro TEST_V_VS_POWER, nbp=nbp, test=test
;
; on ferme toutes les fenetres actives afin que
; la succession des traces soit claire !
;
AC_RESET
;
; selection interactive d'un bolo
;
bolo=LIST_BOLO_SELECT()
if (N_TAGS(bolo) LE 0) then begin
    print, mess.fatal+'No selected bolo !'
    return
endif
;
if (N_ELEMENTS(nbp) EQ 0) then nbp=1e5
;
delta_t=1e-4
;
; we create a step-increasing array of incoming optical flux
;
if (N_ELEMENTS(back) EQ 0) then back=3.8e-13
;
OptSteps=ROUND(FINDGEN(nbp)/500)
OptSteps=OptSteps/(MAX(OptSteps)/back)*100.+back
;
; on a renormalise entre 0 et 1 et on met a back
;
; ----------------------------------------
;
T_bath=0.100
;
t=BOLO_DIRECT_MODEL(OptSteps, bolo=bolo, t_bath=T_bath, $
                    current=current, debug=2)
;
; conversion Temperature --> Voltage
;
v=TEMPERATURE2VOLTAGE(t, current, bolo=bolo)
;
i_mean=MEAN(current,/double)
;
; les 1ers points sont hors echelle
;
start=500
;
window,0
plot, OptSteps(start:*), t(start:*), xtitle='Optical power', $
  ytitle='Bolo Temperature', title='Bolo Temperature versus Optical power'
XYOUTS, AC_XYOUTS(0.6, /X), AC_XYOUTS(0.1, /Y), 'T_bath :'+STRING(T_bath)
XYOUTS, AC_XYOUTS(0.6, /X), AC_XYOUTS(0.2, /Y), 'Mean Current :'+STRING(i_mean)
;
window,1
plot, OptSteps(start:*), v(start:*), xtitle='Optical power', $
  ytitle='Bolo Voltage', title='Bolo Voltage versus Optical power'
XYOUTS, AC_XYOUTS(0.6, /X), AC_XYOUTS(0.8, /Y), 'T_bath :'+STRING(T_bath)
XYOUTS, AC_XYOUTS(0.6, /X), AC_XYOUTS(0.9, /Y), 'Mean Current :'+STRING(i_mean)
;
if KEYWORD_SET(test) then STOP
;
end
